package com.xhkjedu.smarking.service.report.report;

import com.alibaba.fastjson.JSON;
import com.xhkjedu.smarking.mapper.exam.MsClassMapper;
import com.xhkjedu.smarking.mapper.report.reportclass.MsrClassQuestionMapper;
import com.xhkjedu.smarking.mapper.report.reportclass.MsrClassSubjectGradeMapper;
import com.xhkjedu.smarking.mapper.report.reportother.MsrReportparamMapper;
import com.xhkjedu.smarking.mapper.report.reportsubject.MsrSubjectMapper;
import com.xhkjedu.smarking.model.exam.MsClass;
import com.xhkjedu.smarking.model.report.reportclass.MsrClassQuestion;
import com.xhkjedu.smarking.model.report.reportclass.MsrClassSubjectGrade;
import com.xhkjedu.smarking.model.report.reportother.MsrReportparam;
import com.xhkjedu.smarking.vo.report.reportother.ExamReportParams;
import com.xhkjedu.smarking.vo.report.reportother.SzJsonVo;
import com.xhkjedu.utils.N_Utils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description：试题表
 * @Author: WN
 * @Date: 2024/12/24 9:47:39
 **/
@Service
public class MsrClassQuestionService {
    @Resource
    private MsrClassSubjectGradeMapper msrClassSubjectGradeMapper;
    @Resource
    private MsrSubjectMapper msrSubjectMapper;
    @Resource
    private MsrReportparamMapper msrReportparamMapper;
    @Resource
    private MsrClassQuestionMapper msrClassQuestionMapper;
    @Resource
    private MsClassMapper msClassMapper;


    //综合报告-试题汇总表-全部班级-科目情况
    public Map<String,Object> getSubjectForAllSmall(MsrClassSubjectGrade subjectGrade){
        //获取科目基础信息
        Map<String,Object> subjectMap = msrSubjectMapper.getSubjectBaseInfo(subjectGrade.getExamid(),subjectGrade.getSubjectid());
        subjectGrade.setClassid(0);
        subjectGrade.setReportcode("zh");
        //获取科目四率
        List<MsrClassSubjectGrade> subjectGradeList = msrClassSubjectGradeMapper.listSubjectGrade(subjectGrade);
        subjectMap.put("subjectGradeList",subjectGradeList);

        //获取四率参数
        MsrReportparam reportparam = msrReportparamMapper.getReportparamByRpbelongSubject(subjectGrade.getExamid(),"scorerate","zh",subjectGrade.getSubjectid());

        Map<String,Object> rtnMap = new HashMap<>();
        rtnMap.put("reportparam",reportparam);
        rtnMap.put("subject",subjectMap);

        return rtnMap;
    }
    //综合报告-试题汇总表-全部分类-按小题分析
    public Map<String,Object> listQuestionForAllSmall(ExamReportParams params){
        List<Map<String,Object>> questionList = msrClassQuestionMapper.listQuestionSummaryForSmall(params);
        List<Map<String,Object>> objlist;
        List<Map<String,Object>> sublist;
        if(params.getSelclass() == 2){//选择班级类型1全体 2全部班级对比 3指定班级对比 4单个班级
            //获取考试关联班级
            List<MsClass> classList= msClassMapper.listClassByExamidAndSubjectid(params.getExamid(),params.getSubjectid());

            objlist = new ArrayList<>();
            sublist = new ArrayList<>();

            //初始化学校全体
            List<Map<String,Object>> allSchool = questionList.stream().filter(m -> m.get("classid").equals(0)).collect(Collectors.toList());
            for(Map<String,Object> school : allSchool){
                school.put("classname","学校全体");
                if(school.get("qtype").equals("1")){
                    objlist.add(school);
                }else{
                    sublist.add(school);
                }
            }

            for(MsClass c : classList){
                List<Map<String,Object>> classQues = questionList.stream().filter(m -> m.get("classid").equals(c.getClassid())).collect(Collectors.toList());
                for(Map<String,Object> cq : classQues){
                    cq.put("classname",c.getClassname());
                    if(cq.get("qtype").equals("1")){
                        objlist.add(cq);
                    }else{
                        sublist.add(cq);
                    }
                }
            }
        }else{
            objlist = questionList.stream().filter(m -> m.get("qtype").equals("1")).collect(Collectors.toList());
            sublist = questionList.stream().filter(m -> m.get("qtype").equals("2")).collect(Collectors.toList());
        }

        Map<String,Object> rtnMap = new HashMap<>();
        rtnMap.put("objlist",objlist);
        rtnMap.put("sublist",sublist);
        return rtnMap;
    }
    //综合报告-试题汇总表-全部分类-按大题分析
    public List<Map<String,Object>> listQuestionForAllQtype(ExamReportParams params){
        return msrClassQuestionMapper.listQuestionSummaryForQtype(params);
    }

    //综合报告-试题汇总表-全部分类-按主(客)题分析
    public List<Map<String,Object>> listQuestionForAllObjsub(ExamReportParams params){
        return msrClassQuestionMapper.listQuestionSummaryForObjsub(params);
    }

    //学科报告-各班学科试题分析-得分率
    public Map<String,Object> listQuestionForXhXhstDfl(ExamReportParams params){
        params.setSelclass(3);
        params.setClassids("0," + params.getClassids());//拼上全体
        //获取选定班级的试题分析
        List<MsrClassQuestion> questions = msrClassQuestionMapper.listQuestionForXh(params);
        //获取全体试题情况
        List<MsrClassQuestion> schoolQuestions = questions.stream().filter(m -> m.getClassid() == 0).collect(Collectors.toList());
        List<MsrClassQuestion> classQuestions = questions.stream().filter(m -> m.getClassid() != 0).collect(Collectors.toList());
        //获取所有题号
        List<String> qns = new ArrayList<>();
        //获取全体得分率数据
        List<Map<String,Object>> schoolScoreRate = new ArrayList<>();
        Map<Integer,Object> mptqidScore = new LinkedHashMap<>();//全体各题得分率
        for(MsrClassQuestion q : schoolQuestions){
            Map<String,Object> qMap = new HashMap<>();
            qMap.put("qn",q.getQn());
            qMap.put("mptqid",q.getMptqid());
            qMap.put("qorder",q.getQorder());
            qMap.put("scorerate",q.getScorerate());
            schoolScoreRate.add(qMap);
            mptqidScore.put(q.getMptqid(),q.getScorerate());
            qns.add(q.getQn());
        }

        //把试题按班级分组
        Map<Integer,List<MsrClassQuestion>> classMap = classQuestions.stream().collect(Collectors.groupingBy(MsrClassQuestion::getClassid));
        List<Map<String,Object>> classList = new ArrayList<>();//班级试题得分率差
        for(Map.Entry<Integer,List<MsrClassQuestion>> entry : classMap.entrySet()){
            List<MsrClassQuestion> classQueList = entry.getValue();
            List<Map<String,Object>> queList = new ArrayList<>();
            for(MsrClassQuestion q : classQueList) {
                Map<String, Object> qMap = new HashMap<>();
                qMap.put("qn", q.getQn());
                qMap.put("mptqid", q.getMptqid());
                qMap.put("qorder", q.getQorder());
                qMap.put("scorerate", q.getScorerate());
                qMap.put("scoreratec", q.getScoreratec());
                qMap.put("schoolscorerate", mptqidScore.get(q.getMptqid()));
                queList.add(qMap);
            }

            Map<String,Object> clMap = new HashMap<>();
            clMap.put("classid",entry.getKey());
            clMap.put("classname",classQueList.get(0).getClassname());
            clMap.put("questions",queList.stream().sorted(Comparator.comparing(m -> (Integer) m.get("qorder"))).collect(Collectors.toList()));
            classList.add(clMap);
        }

        //分析诊断-得分率高于全体得分率的班级和试题
        List<MsrClassQuestion> highQuestions = new ArrayList<>();//高于全体得分率的试题情况
        for(MsrClassQuestion q : schoolQuestions){
            List<MsrClassQuestion> hightClass = questions.stream().filter(m -> m.getMptqid().equals(q.getMptqid()) && m.getClassid() != 0 && m.getScorerate() > q.getScorerate()).collect(Collectors.toList());
            if(!hightClass.isEmpty()){
                highQuestions.addAll(hightClass);
            }
        }
        //高分按班级分组，哪个班级试题数量多，则属于高班和试题(统计高于年级平均值的试题数量，看哪个班级最多)
        Map<Integer,List<MsrClassQuestion>> highClassMap = highQuestions.stream().collect(Collectors.groupingBy(MsrClassQuestion::getClassid));
        int maxNum = 0;
        List<MsrClassQuestion> maxClassQuestions = new ArrayList<>();
        for(Map.Entry<Integer,List<MsrClassQuestion>> entry : highClassMap.entrySet()){
            if(entry.getValue().size() > maxNum){
                maxNum = entry.getValue().size();
                maxClassQuestions.addAll(entry.getValue());
            }
        }
        Map<String,Object> highMap = new HashMap<>();//高得分率分析
        if(!maxClassQuestions.isEmpty()){
            highMap.put("classname",maxClassQuestions.get(0).getClassname());
            highMap.put("qnstr",maxClassQuestions.stream().map(MsrClassQuestion::getQn).distinct().collect(Collectors.joining(",")));
        }
        //列出各个难度的试题中，得分率低于60%的试题,用全体试题的得分率进行难度分组
        Map<String,List<MsrClassQuestion>> ndMap = schoolQuestions.stream().collect(Collectors.groupingBy(MsrClassQuestion::getNdms));
        //获取所有试题难度分组参数
        MsrReportparam ndParam = msrReportparamMapper.getReportparamByRpbelongSubjectType(params.getExamid(),"quesummary","all",params.getSubjectid(),1);
        List<SzJsonVo> jsonList = JSON.parseArray(ndParam.getSzjson(), SzJsonVo.class);
        List<Map<String,Object>> ndList = new ArrayList<>();
        for(SzJsonVo szvo : jsonList){
            Map<String,Object> zsndMap = new HashMap<>();
            zsndMap.put("djkey",szvo.getDjkey());
            String qnStr = "";
            if(ndMap.containsKey(szvo.getDjkey())){
                List<MsrClassQuestion> ndQues = ndMap.get(szvo.getDjkey());
                //获取得分率低于60%的试题
                List<MsrClassQuestion> lowQuestions = ndQues.stream().filter(m -> m.getScorerate() < 0.6).collect(Collectors.toList());
                if(!lowQuestions.isEmpty()){
                    qnStr = lowQuestions.stream().map(MsrClassQuestion::getQn).distinct().collect(Collectors.joining(","));
                }
            }
            if(N_Utils.isEmpty(qnStr)){
                qnStr = "无";
            }
            zsndMap.put("qnstr",qnStr);

            ndList.add(zsndMap);
        }
        //计算各个难度的试题得分率
        for(Map<String,Object> nd : ndList) {
            List<MsrClassQuestion> ndQuestions = schoolQuestions.stream().filter(m -> m.getNdms().equals(nd.get("ndms"))).collect(Collectors.toList());
        }

        Map<String,Object> rtnMap = new LinkedHashMap<>();
        rtnMap.put("qns",qns);
        rtnMap.put("schoolQues",schoolScoreRate);
        rtnMap.put("classQues",classList);
        rtnMap.put("highMap",highMap);
        rtnMap.put("ndList",ndList);
        return rtnMap;
    }
    //学科报告-各班学科试题分析-试题难度和区分度
    public void listQuestionForXhXhstNdAndQfd(ExamReportParams params){
        params.setSelclass(4);
        //获取选定班级的试题分析
        List<MsrClassQuestion> questions = msrClassQuestionMapper.listQuestionForXh(params);
        //表现较好的题目和表现不足的题目，根据得分率差进行排序
        List<MsrClassQuestion> goodAndBadQues = questions.stream().sorted(Comparator.comparing(MsrClassQuestion::getScoreratec).reversed()).collect(Collectors.toList());
        List<MsrClassQuestion> firstN;
        List<MsrClassQuestion> lastN;
        int n = 5;
        if(goodAndBadQues.size() < n){
            n = goodAndBadQues.size()/2;
        }
        // 获取前N个元素
        firstN = goodAndBadQues.stream().limit(n).collect(Collectors.toList());
        // 获取后N个元素
        lastN = goodAndBadQues.stream().skip(goodAndBadQues.size() - n).collect(Collectors.toList());

        

        //获取所有题号
        List<String> qns = questions.stream().map(MsrClassQuestion::getQn).distinct().collect(Collectors.toList());
        //把试题按班级分组
        Map<Integer,List<MsrClassQuestion>> classMap = questions.stream().collect(Collectors.groupingBy(MsrClassQuestion::getClassid));
        List<Map<String,Object>> classList = new ArrayList<>();//班级试题
        for(Map.Entry<Integer,List<MsrClassQuestion>> entry : classMap.entrySet()){
            Map<String,Object> clMap = new HashMap<>();
            clMap.put("classid",entry.getKey());
            clMap.put("classname",entry.getValue().get(0).getClassname());
            clMap.put("questions",entry.getValue());
            classList.add(clMap);
        }
    }


}
