package com.xhkjedu.sstudy.model.bk;

import com.xhkjedu.model.BaseBean;
import lombok.Data;

import javax.persistence.*;

@Table(name = "t_bk")
@Data
public class TBk extends BaseBean {
    /**
     * 课堂备课表
     */
    @Id
    private Integer bkid;

    /**
     * 教材ID
     */
    private String lsbid;

    /**
     * 章节ID
     */
    private String directorid;

    /**
     * 备课类型1提问2考试3投票4资料
     */
    private Integer bktype;

    /**
     * 互动类型30判断题31选择题32简答题33画图题50投票
     */
    private Integer asktype;

    /**
     * 备课标题
     */
    private String bktitle;

    /**
     * 时长（分钟）
     */
    private Integer duration;

    /**
     * 考试试题数量
     */
    private Integer papernum;

    /**
     * 考试分值
     */
    private Double paperscore;

    /**
     * 投票类型（如10选5）
     */
    private String votetype;

    /**
     * 资料大小
     */
    private Integer inforsize;

    /**
     * 资料后缀
     */
    private String inforsuffix;

    /**
     * 资料文件地址
     */
    private String inforpath;

    /**
     * 资料文件pdf地址
     */
    private String inforpdf;

    /**
     * 互动封面图地址
     */
    private String imgpath;

    /**
     * 备课内容信息json
     */
    private String bkjson;

    /**
     * 创建人ID
     */
    private Integer createid;

    /**
     * 创建时间
     */
    private Integer createtime;

    /**
     * 操作人ID
     */
    private Integer updateid;

    /**
     * 操作时间
     */
    private Integer updatetime;

    /**
     * 学校ID
     */
    private Integer schoolid;

    @Transient
    private Integer directorLeaf;//章节是否是叶子节点0不是1是

    @Transient
    private String directorall;//所有层章节拼接
}